import { Task } from '@kevisual/task';
import { app } from '@/app.ts';
import { Queue } from 'bullmq';
import { redis } from '@/modules/redis.ts';
import { logger } from '@/modules/logger.ts';
export const task = new Task({
  name: 'file-listener-tasks',
  app,
  redis,
});

export const cornTask = new Task({
  name: 'file-listener-tasks-corn',
  app,
  redis,
});
const corn = '0 3 1 * *'; // 设置每个月1号3点执行一次的定时任务的cron
export const runCorn = async () => {
  const queue: Queue = cornTask.getQueue();

  try {
    const key = 'file-listener-sync-all';
    const existId = '8a815571879a730532471d952958fc71'; // 确保唯一性
    const pattern = corn;
    // const existingJobs = await queue.getJobScheduler(existId);
    const job = await queue.add(
      'file-listener-tasks-corn',
      {
        path: 'file-listener',
        key: 'db-check',
      },
      {
        jobId: key,
        repeat: {
          pattern: pattern,
          key: '8a815571879a730532471d952958fc71', // 确保唯一性
        },
      },
    );
    logger.info('Created new repeatable job:', job.id, job.name, job.repeatJobKey);
    logger.info(`Created new repeatable job with cron pattern: ${pattern}`);
  } catch (error) {
    logger.error('Error managing job schedulers:', error);
  }

  const worker = cornTask.getWorker();
  return worker;
};
